#############################################################################
##########################           giving unique ID         ############################
#############################################################################

echo "enter the name of gff file: ";
read gff;
cp $gff $PWD/test_gff;
echo "enter the name of genome file: ";
read genome;
cp $genome $PWD/gen_test;
cat gen_test | sed '/^>/d' >gen_test1
rm -rf gen_test
cat gen_test1 >gen_test
echo "granting UNIQUE-ID";
cat test_gff | grep -n $ >1
cat 1 >ID_$gff;
echo "    C";
echo "    O";
cat 1| awk '{print $1, $3, $4, $5, $7}' | sed 's/:/ /g' | awk '{print $1, $3, $4, $5, $6}' >2
cat 2 | egrep -i "gene|exon|CDS" >3
echo "    M";
echo "    P";
perl uniq_gff.pl		 #output = " final1 "
echo "    L";
echo "    E";
rm -rf test_result gen_test1
echo "    T";
echo "    E";
echo

#############################################################################
################                      fetching the gene sequences                     ###################
#############################################################################

echo "fetching the gene sequences";
cat final1 | awk '{ if($1=="gene") {print $1, $2, $3-$2, $4, $5}}' | grep '+' | awk '{print $2}' >gene+start 
echo "    C";
cat final1 | awk '{ if($1=="gene") {print $1, $2, $3-$2, $4, $5}}' | grep '+' | awk '{print $3}' >gene+length
echo "    O";
cat final1 | awk '{ if($1=="gene") {print $1, $2, $3-$2, $4, $5}}' | grep '+' | awk '{print $5}' >gene+ID
echo "    M";
cat final1 | awk '{ if($1=="gene") {print $1, $2, $3-$2, $4, $5}}' | grep '-' | awk '{print $2}' >gene-start
echo "    P";
cat final1 | awk '{ if($1=="gene") {print $1, $2, $3-$2, $4, $5}}' | grep '-' | awk '{print $3}' >gene-length
echo "    L";
cat final1 | awk '{ if($1=="gene") {print $1, $2, $3-$2, $4, $5}}' | grep '-' | awk '{print $5}' >gene-ID
echo "    E";
perl fetching_genes_gff.pl
echo "    T";
cat gene_seq_1 gene_seq_2 >gene_$genome
echo "    E";
echo
rm -rf gene+start gene+length gene+ID gene-start gene-length gene-ID gene_seq_1 gene_seq_2

#############################################################################
################                      fetching the exon sequences                     ###################
#############################################################################

echo "fetching the exon sequences";
cat final1 | awk '{ if($1=="exon") {print $1, $2, $3-$2, $4, $5}}' | grep '+' | awk '{print $2}' >exon+start 
echo "    C";
cat final1 | awk '{ if($1=="exon") {print $1, $2, $3-$2, $4, $5}}' | grep '+' | awk '{print $3}' >exon+length
echo "    O";
cat final1 | awk '{ if($1=="exon") {print $1, $2, $3-$2, $4, $5}}' | grep '+' | awk '{print $5}' >exon+ID
echo "    M";
cat final1 | awk '{ if($1=="exon") {print $1, $2, $3-$2, $4, $5}}' | grep '-' | awk '{print $2}' >exon-start
echo "    P";
cat final1 | awk '{ if($1=="exon") {print $1, $2, $3-$2, $4, $5}}' | grep '-' | awk '{print $3}' >exon-length
echo "    L";
cat final1 | awk '{ if($1=="exon") {print $1, $2, $3-$2, $4, $5}}' | grep '-' | awk '{print $5}' >exon-ID
echo "    E";
perl fetching_exons_gff.pl
echo "    T";
cat exon_seq_1 exon_seq_2 >exon_$genome
echo "    E";
echo
rm -rf exon+start exon+length exon+ID exon-start exon-length exon-ID exon_seq_1 exon_seq_2

#############################################################################
################                      fetching the CDS sequences                   ####################
#############################################################################

echo "fetching the CDS sequences";
cat final1 | awk '{ if($1=="CDS") {print $1, $2, $3-$2, $4, $5}}' | grep '+' | awk '{print $2}' >CDS+start 
cat final1 | awk '{ if($1=="CDS") {print $1, $2, $3-$2, $4, $5}}' | grep '+' | awk '{print $3}' >CDS+length
echo "    C";
cat final1 | awk '{ if($1=="CDS") {print $1, $2, $3-$2, $4, $5}}' | grep '+' | awk '{print $5}' >CDS+ID
echo "    O";
perl fetching_CDS_gff_A.pl
echo "    M";
cat final1 | awk '{ if($1=="CDS") {print $1, $2, $3-$2, $4, $5}}' | grep '-' | awk '{print $2}' >CDS-start
echo "    P";
cat final1 | awk '{ if($1=="CDS") {print $1, $2, $3-$2, $4, $5}}' | grep '-' | awk '{print $3}' >CDS-length
echo "    L";
cat final1 | awk '{ if($1=="CDS") {print $1, $2, $3-$2, $4, $5}}' | grep '-' | awk '{print $5}' >CDS-ID
echo "    E";
perl fetching_CDS_gff_B.pl
echo "    T";
perl fetching_CDS_gff.pl
echo "    E";
echo
cat CDS_seq_1 CDS_seq_2 >CDS_seqs1
perl merge_CDS.pl
cat CDS_seqs >CDS_$genome
rm -rf CDS_seqs

#############################################################################
####       fetching the mRNA sequences - by reverse transcribing CDS only        #############
#############################################################################

echo "fetching the mRNA sequences";
perl fetching_mRNA_gff.pl
echo "    C";
echo "    O";
echo "    M";
echo "    P";
cat mRNA_seq_1 mRNA_seq_2 >mRNA_seqs1
echo "    L";
echo "    E";
echo "    T";
echo "    E";
echo
perl merge_mRNA.pl
cat mRNA_seqs >mRNA_$genome
rm -rf CDS+start CDS+length CDS+ID CDS-start CDS-length CDS-ID mRNA_seq_1 mRNA_seq_2 2 count count2 CDS_seq_1 CDS_seq_2 CDS+A CDS-B mRNA_seqs1 CDS_seqs1 mRNA_seqs

#############################################################################
################                    fetching the intron sequences                  ####################
#############################################################################

echo "fetching the intron sequences";
cat final1 | egrep -i 'exon' | awk '{ if($4=="+") {print $1, $2, $3, $4, $5}}' >intron+1
cat final1 | egrep -i 'exon' | awk '{ if($4=="-") {print $1, $2, $3, $4, $5}}' >intron-1
perl fetching_introns_gff_1.pl                  #output = intron+1_out
echo "    C";
cat intron-1 | sort >intron-1-2
echo "    O";
perl fetching_introns_gff_2.pl			#output = intron-1_out
echo "    M";
cat intron+1_out |awk '$6 ~ /^[0-9]/' | awk '{print $7}' >introns+start
echo "    P";
cat intron+1_out |awk '$6 ~ /^[0-9]/' | awk '{print $6}' >introns+length
echo "    L";
cat intron+1_out |awk '$6 ~ /^[0-9]/' | awk '{print $5}' >introns+ID
echo "    E";
 cat intron-1_out |awk '$6 ~ /^[0-9]/' | awk '{print $7}' >introns-start
echo "    T";
cat intron-1_out |awk '$6 ~ /^[0-9]/' | awk '{print $6}' >introns-length
echo "    E";
echo
cat intron-1_out |awk '$6 ~ /^[0-9]/' | awk '{print $5}' >introns-ID
perl fetching_introns_gff.pl
cat introns_seq_1 introns_seq_2 >intron_$genome
rm -rf intron+1 intron-1 intron+1_out intron-1_out intron-1-2 introns+start introns+length introns+ID introns-start introns-length introns-ID introns_seq_1 introns_seq_2 count count2

#############################################################################
################               fetching the intergenic sequences                ####################
#############################################################################

echo "fetching the intergenic sequences";
cat final1 | grep 'gene' >intergenic_1
perl fetching_intergenic_gff_1.pl			#output	=	intergenic_1_out
echo "    C";
cat intergenic_1_out | awk '$6 ~ /^[0-9]/' | grep '+' | awk '{print $6}' >intergenic+length
echo "    O";
cat intergenic_1_out | awk '$6 ~ /^[0-9]/' | grep '+' | awk '{print $7}' >intergenic+start
echo "    M";
cat intergenic_1_out | awk '$6 ~ /^[0-9]/' | grep '+' | awk '{print $8}' >intergenic+ID
echo "    P";
cat intergenic_1_out | awk '$6 ~ /^[0-9]/' | grep '-' | awk '{print $6}' >intergenic-length
echo "    L";
cat intergenic_1_out | awk '$6 ~ /^[0-9]/' | grep '-' | awk '{print $7}' >intergenic-start
echo "    E";
cat intergenic_1_out | awk '$6 ~ /^[0-9]/' | grep '-' | awk '{print $8}' >intergenic-ID
echo "    T";
perl fetching_intergenic_gff.pl
echo "    E";
echo
cat intergenic_seq_1 intergenic_seq_2 >intergenic_$genome
rm -rf intergenic_1 intergenic_1_out count count2 intergenic+length intergenic+start intergenic+ID intergenic-length intergenic-start intergenic-ID intergenic_seq_1 intergenic_seq_2

#############################################################################
##############              fetching the promoter/upstream sequences            #################
#############################################################################

echo "fetching promoter/upstream sequences";
echo
./fetching_promoter_shell_A.sh
echo "    C";
echo "    O";
perl fetching_promoter_gff.pl
echo "    M";
echo "    P";
cat pro_seq_1 pro_seq_2 >upstream_$genome
echo "    L";
echo "    E";
rm -rf pro_1 pro+start pro+length pro+ID pro-start pro-length pro-ID count count2 pro_seq_1 pro_seq_2 final1
rm -rf test_gff 1 gen_test 3
echo "    T";
echo "    E";
echo


echo
echo "Thanks for using  ACHALz GFF-Extractor !!!!"
echo
